//+------------------------------------------------------------------+
//|                                !MBO_Binary_Options_Simulator.mq4 |
//|                                            MetaBinaryOptions.com |
//|                                    https://MetaBinaryOptions.com |
//+------------------------------------------------------------------+
#property copyright "MetaBinaryOptions.com"
#property link      "https://MetaBinaryOptions.com"
#property version   "1.00"
#property strict
#property indicator_chart_window

extern double balance=1000; //Starting Balance
extern double payout=80; //Payout Percentage

double binary[][6]; //openTime, openPrice, expirySec, direction, amount, output;
int orders=0;
int nbwin=0, nbloss=0, nbeven=0;
double winratio=0;
double price=0;

int file_handle;
int drawIndex=0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
  //if(TimeCurrent()>0) {
      ObjectsDeleteAll(0);
      ArrayInitialize(binary,0.0);
      ArrayFree(binary);
      orders=0;
      nbwin=0; nbloss=0; nbeven=0;
      winratio=0;
      price=0;
      drawIndex=0;
          
      ChartSetInteger(0,CHART_MODE,CHART_CANDLES);
      ChartSetInteger(0,CHART_FOREGROUND,false);
      ChartSetInteger(0,CHART_SHIFT,true);
      ChartSetInteger(0,CHART_AUTOSCROLL,true);
      ChartSetInteger(0,CHART_SCALE,3);
      ChartSetInteger(0,CHART_SCALEFIX,false);
      ChartSetInteger(0,CHART_SCALEFIX_11,false);
      ChartSetInteger(0,CHART_SCALE_PT_PER_BAR,false);
      ChartSetInteger(0,CHART_SHOW_OHLC,false);
      ChartSetInteger(0,CHART_SHOW_BID_LINE,true);
      ChartSetInteger(0,CHART_SHOW_ASK_LINE,false);
      ChartSetInteger(0,CHART_SHOW_LAST_LINE,false);
      ChartSetInteger(0,CHART_SHOW_PERIOD_SEP,false);
      ChartSetInteger(0,CHART_SHOW_GRID,false);
      ChartSetInteger(0,CHART_SHOW_VOLUMES,false);
      ChartSetInteger(0,CHART_SHOW_OBJECT_DESCR,false);
      ChartSetInteger(0,CHART_COLOR_BACKGROUND,C'255,255,255');
      ChartSetInteger(0,CHART_COLOR_FOREGROUND,DarkGray);
      ChartSetInteger(0,CHART_COLOR_GRID,DarkGray);
      ChartSetInteger(0,CHART_COLOR_VOLUME,DarkGray);
      ChartSetInteger(0,CHART_COLOR_CHART_UP,C'0,174,232');
      ChartSetInteger(0,CHART_COLOR_CHART_DOWN,C'173,173,173');
      ChartSetInteger(0,CHART_COLOR_CHART_LINE,Gray);
      ChartSetInteger(0,CHART_COLOR_CANDLE_BULL,C'0,174,232');
      ChartSetInteger(0,CHART_COLOR_CANDLE_BEAR,C'173,173,173');
      ChartSetInteger(0,CHART_COLOR_BID,DarkGray);
      ChartSetInteger(0,CHART_COLOR_ASK,DarkGray);
      ChartSetInteger(0,CHART_COLOR_LAST,DarkGray);
      ChartSetInteger(0,CHART_COLOR_STOP_LEVEL,DarkGray);
      ChartSetInteger(0,CHART_SHOW_TRADE_LEVELS,false);
      ChartSetInteger(0,CHART_DRAG_TRADE_LEVELS,false);
      ChartSetInteger(0,CHART_SHOW_DATE_SCALE,true);
      ChartSetInteger(0,CHART_SHOW_PRICE_SCALE,true);
      ChartSetInteger(0,CHART_SHOW_ONE_CLICK,false);
      
      long result=-1;
      ChartGetInteger(0,CHART_WIDTH_IN_PIXELS,0,result);
      ChartSetDouble(0,CHART_SHIFT_SIZE,300.0*100.0/(result*1.0)+1.0);
      
          ObjectCreate(0,"MetaBinaryOptions-Label1",OBJ_LABEL,0,0,0);
      ObjectSetInteger(0,"MetaBinaryOptions-Label1",OBJPROP_XDISTANCE,5);
      ObjectSetInteger(0,"MetaBinaryOptions-Label1",OBJPROP_YDISTANCE,10);
      ObjectSetInteger(0,"MetaBinaryOptions-Label1",OBJPROP_CORNER,CORNER_LEFT_UPPER);
       ObjectSetString(0,"MetaBinaryOptions-Label1",OBJPROP_TEXT,"META");
       ObjectSetString(0,"MetaBinaryOptions-Label1",OBJPROP_FONT,"Arial");
      ObjectSetInteger(0,"MetaBinaryOptions-Label1",OBJPROP_FONTSIZE,18);
       ObjectSetDouble(0,"MetaBinaryOptions-Label1",OBJPROP_ANGLE,0.0);
      ObjectSetInteger(0,"MetaBinaryOptions-Label1",OBJPROP_ANCHOR,ANCHOR_LEFT_UPPER);
      ObjectSetInteger(0,"MetaBinaryOptions-Label1",OBJPROP_COLOR,C'173,173,173');
      ObjectSetInteger(0,"MetaBinaryOptions-Label1",OBJPROP_BACK,false);
      ObjectSetInteger(0,"MetaBinaryOptions-Label1",OBJPROP_SELECTABLE,false);
      ObjectSetInteger(0,"MetaBinaryOptions-Label1",OBJPROP_SELECTED,false);
      ObjectSetInteger(0,"MetaBinaryOptions-Label1",OBJPROP_HIDDEN,true);
      ObjectSetInteger(0,"MetaBinaryOptions-Label1",OBJPROP_ZORDER,10);
      
          ObjectCreate(0,"MetaBinaryOptions-Label2",OBJ_LABEL,0,0,0);
      ObjectSetInteger(0,"MetaBinaryOptions-Label2",OBJPROP_XDISTANCE,0);
      ObjectSetInteger(0,"MetaBinaryOptions-Label2",OBJPROP_YDISTANCE,10);
      ObjectSetInteger(0,"MetaBinaryOptions-Label2",OBJPROP_CORNER,CORNER_LEFT_UPPER);
       ObjectSetString(0,"MetaBinaryOptions-Label2",OBJPROP_TEXT,"          BINARY");
       ObjectSetString(0,"MetaBinaryOptions-Label2",OBJPROP_FONT,"Arial");
      ObjectSetInteger(0,"MetaBinaryOptions-Label2",OBJPROP_FONTSIZE,18);
       ObjectSetDouble(0,"MetaBinaryOptions-Label2",OBJPROP_ANGLE,0.0);
      ObjectSetInteger(0,"MetaBinaryOptions-Label2",OBJPROP_ANCHOR,ANCHOR_LEFT_UPPER);
      ObjectSetInteger(0,"MetaBinaryOptions-Label2",OBJPROP_COLOR,C'0,174,232');
      ObjectSetInteger(0,"MetaBinaryOptions-Label2",OBJPROP_BACK,false);
      ObjectSetInteger(0,"MetaBinaryOptions-Label2",OBJPROP_SELECTABLE,false);
      ObjectSetInteger(0,"MetaBinaryOptions-Label2",OBJPROP_SELECTED,false);
      ObjectSetInteger(0,"MetaBinaryOptions-Label2",OBJPROP_HIDDEN,true);
      ObjectSetInteger(0,"MetaBinaryOptions-Label2",OBJPROP_ZORDER,10);
      
          ObjectCreate(0,"MetaBinaryOptions-Label3",OBJ_LABEL,0,0,0);
      ObjectSetInteger(0,"MetaBinaryOptions-Label3",OBJPROP_XDISTANCE,0);
      ObjectSetInteger(0,"MetaBinaryOptions-Label3",OBJPROP_YDISTANCE,10);
      ObjectSetInteger(0,"MetaBinaryOptions-Label3",OBJPROP_CORNER,CORNER_LEFT_UPPER);
       ObjectSetString(0,"MetaBinaryOptions-Label3",OBJPROP_TEXT,"                      OPTIONS");
       ObjectSetString(0,"MetaBinaryOptions-Label3",OBJPROP_FONT,"Arial");
      ObjectSetInteger(0,"MetaBinaryOptions-Label3",OBJPROP_FONTSIZE,18);
       ObjectSetDouble(0,"MetaBinaryOptions-Label3",OBJPROP_ANGLE,0.0);
      ObjectSetInteger(0,"MetaBinaryOptions-Label3",OBJPROP_ANCHOR,ANCHOR_LEFT_UPPER);
      ObjectSetInteger(0,"MetaBinaryOptions-Label3",OBJPROP_COLOR,C'173,173,173');
      ObjectSetInteger(0,"MetaBinaryOptions-Label3",OBJPROP_BACK,false);
      ObjectSetInteger(0,"MetaBinaryOptions-Label3",OBJPROP_SELECTABLE,false);
      ObjectSetInteger(0,"MetaBinaryOptions-Label3",OBJPROP_SELECTED,false);
      ObjectSetInteger(0,"MetaBinaryOptions-Label3",OBJPROP_HIDDEN,true);
      ObjectSetInteger(0,"MetaBinaryOptions-Label3",OBJPROP_ZORDER,10);
      
          ObjectCreate(0,"MetaBinaryOptions-Label4",OBJ_LABEL,0,0,0);
      ObjectSetInteger(0,"MetaBinaryOptions-Label4",OBJPROP_XDISTANCE,0);
      ObjectSetInteger(0,"MetaBinaryOptions-Label4",OBJPROP_YDISTANCE,10);
      ObjectSetInteger(0,"MetaBinaryOptions-Label4",OBJPROP_CORNER,CORNER_LEFT_UPPER);
       ObjectSetString(0,"MetaBinaryOptions-Label4",OBJPROP_TEXT,"                                     .com");
       ObjectSetString(0,"MetaBinaryOptions-Label4",OBJPROP_FONT,"Arial");
      ObjectSetInteger(0,"MetaBinaryOptions-Label4",OBJPROP_FONTSIZE,18);
       ObjectSetDouble(0,"MetaBinaryOptions-Label4",OBJPROP_ANGLE,0.0);
      ObjectSetInteger(0,"MetaBinaryOptions-Label4",OBJPROP_ANCHOR,ANCHOR_LEFT_UPPER);
      ObjectSetInteger(0,"MetaBinaryOptions-Label4",OBJPROP_COLOR,C'173,173,173');
      ObjectSetInteger(0,"MetaBinaryOptions-Label4",OBJPROP_BACK,false);
      ObjectSetInteger(0,"MetaBinaryOptions-Label4",OBJPROP_SELECTABLE,false);
      ObjectSetInteger(0,"MetaBinaryOptions-Label4",OBJPROP_SELECTED,false);
      ObjectSetInteger(0,"MetaBinaryOptions-Label4",OBJPROP_HIDDEN,true);
      ObjectSetInteger(0,"MetaBinaryOptions-Label4",OBJPROP_ZORDER,10);
     
          ObjectCreate(0,"MetaBinaryOptions-messenger",OBJ_EDIT,0,0,0);
      ObjectSetInteger(0,"MetaBinaryOptions-messenger",OBJPROP_ZORDER,5);
      ObjectSetInteger(0,"MetaBinaryOptions-messenger",OBJPROP_ANCHOR,ANCHOR_CENTER);
       ObjectSetString(0,"MetaBinaryOptions-messenger",OBJPROP_TEXT,"Check MetaBinaryOptions.com for more free indicators!");
      ObjectSetInteger(0,"MetaBinaryOptions-messenger",OBJPROP_COLOR,Gray);
      ObjectSetInteger(0,"MetaBinaryOptions-messenger",OBJPROP_CORNER,CORNER_LEFT_UPPER);
      ObjectSetInteger(0,"MetaBinaryOptions-messenger",OBJPROP_FONTSIZE,8);
      ObjectSetInteger(0,"MetaBinaryOptions-messenger",OBJPROP_XDISTANCE,5);
      ObjectSetInteger(0,"MetaBinaryOptions-messenger",OBJPROP_YDISTANCE,35);
      ObjectSetInteger(0,"MetaBinaryOptions-messenger",OBJPROP_XSIZE,305);
      ObjectSetInteger(0,"MetaBinaryOptions-messenger",OBJPROP_YSIZE,20);
      ObjectSetInteger(0,"MetaBinaryOptions-messenger",OBJPROP_BGCOLOR,White);
       ObjectSetString(0,"MetaBinaryOptions-messenger",OBJPROP_FONT,"Arial");
      ObjectSetInteger(0,"MetaBinaryOptions-messenger",OBJPROP_BORDER_COLOR,Gray);
      ObjectSetInteger(0,"MetaBinaryOptions-messenger",OBJPROP_ALIGN,ALIGN_CENTER);
      
      if(TerminalInfoInteger(TERMINAL_DLLS_ALLOWED)==false){
             ObjectCreate(0,"BOSSwrongdll",OBJ_LABEL,0,0,0);
         ObjectSetInteger(0,"BOSSwrongdll",OBJPROP_ZORDER,10);
         ObjectSetInteger(0,"BOSSwrongdll",OBJPROP_ANCHOR,ANCHOR_LEFT_UPPER);
          ObjectSetString(0,"BOSSwrongdll",OBJPROP_TEXT,"Please allow DLL import in Tools/Options/Expert Advisors.");
         ObjectSetInteger(0,"BOSSwrongdll",OBJPROP_CORNER,CORNER_LEFT_UPPER);
         ObjectSetInteger(0,"BOSSwrongdll",OBJPROP_FONTSIZE,20);
         ObjectSetInteger(0,"BOSSwrongdll",OBJPROP_XDISTANCE,100);
         ObjectSetInteger(0,"BOSSwrongdll",OBJPROP_YDISTANCE,100);
         ObjectSetInteger(0,"BOSSwrongdll",OBJPROP_COLOR,C'237,58,95');
      }
     
          ObjectCreate(0,"MetaBinaryOptions-simulator-bg",OBJ_RECTANGLE_LABEL,0,0,0);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-bg",OBJPROP_ZORDER,3);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-bg",OBJPROP_XDISTANCE,300);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-bg",OBJPROP_YDISTANCE,0);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-bg",OBJPROP_XSIZE,300);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-bg",OBJPROP_YSIZE,1300);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-bg",OBJPROP_BGCOLOR,C'248,248,248');
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-bg",OBJPROP_BORDER_TYPE,BORDER_SUNKEN);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-bg",OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-bg",OBJPROP_COLOR,Orange);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-bg",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-bg",OBJPROP_WIDTH,0);
      
          ObjectCreate(0,"MetaBinaryOptions-simulator-title-label",OBJ_LABEL,0,0,0);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-title-label",OBJPROP_XDISTANCE,150);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-title-label",OBJPROP_YDISTANCE,20);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-title-label",OBJPROP_CORNER,CORNER_RIGHT_UPPER);
       ObjectSetString(0,"MetaBinaryOptions-simulator-title-label",OBJPROP_TEXT,"MBO SIMULATOR");
       ObjectSetString(0,"MetaBinaryOptions-simulator-title-label",OBJPROP_FONT,"Arial");
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-title-label",OBJPROP_FONTSIZE,20);
       ObjectSetDouble(0,"MetaBinaryOptions-simulator-title-label",OBJPROP_ANGLE,0.0);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-title-label",OBJPROP_ANCHOR,ANCHOR_CENTER);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-title-label",OBJPROP_COLOR,C'173,173,173');
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-title-label",OBJPROP_BACK,false);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-title-label",OBJPROP_SELECTABLE,false);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-title-label",OBJPROP_SELECTED,false);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-title-label",OBJPROP_HIDDEN,true);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-title-label",OBJPROP_ZORDER,10);
      
          ObjectCreate(0,"MetaBinaryOptions-simulator-expiry-bg",OBJ_RECTANGLE_LABEL,0,0,0);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-expiry-bg",OBJPROP_ZORDER,4);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-expiry-bg",OBJPROP_XDISTANCE,300);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-expiry-bg",OBJPROP_YDISTANCE,40);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-expiry-bg",OBJPROP_XSIZE,300);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-expiry-bg",OBJPROP_YSIZE,40);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-expiry-bg",OBJPROP_BGCOLOR,C'243,243,243');
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-expiry-bg",OBJPROP_BORDER_TYPE,BORDER_SUNKEN);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-expiry-bg",OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-expiry-bg",OBJPROP_COLOR,Orange);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-expiry-bg",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-expiry-bg",OBJPROP_WIDTH,0);
      
          ObjectCreate(0,"MetaBinaryOptions-simulator-exp-label",OBJ_LABEL,0,0,0);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-label",OBJPROP_ZORDER,5);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-label",OBJPROP_ANCHOR,ANCHOR_CENTER);
       ObjectSetString(0,"MetaBinaryOptions-simulator-exp-label",OBJPROP_TEXT,"Expiry :");
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-label",OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-label",OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-label",OBJPROP_XDISTANCE,250);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-label",OBJPROP_YDISTANCE,59);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-label",OBJPROP_COLOR,Gray);
       ObjectSetString(0,"MetaBinaryOptions-simulator-exp-label",OBJPROP_FONT,"Arial");
       
          ObjectCreate(0,"MetaBinaryOptions-simulator-exp-min",OBJ_EDIT,0,0,0);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-min",OBJPROP_ZORDER,5);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-min",OBJPROP_ANCHOR,ANCHOR_CENTER);
       ObjectSetString(0,"MetaBinaryOptions-simulator-exp-min",OBJPROP_TEXT,"5");
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-min",OBJPROP_COLOR,Gray);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-min",OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-min",OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-min",OBJPROP_XDISTANCE,221);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-min",OBJPROP_YDISTANCE,50);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-min",OBJPROP_XSIZE,40);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-min",OBJPROP_YSIZE,20);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-min",OBJPROP_BGCOLOR,White);
       ObjectSetString(0,"MetaBinaryOptions-simulator-exp-min",OBJPROP_FONT,"Arial");
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-min",OBJPROP_BORDER_COLOR,Gray);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-min",OBJPROP_ALIGN,ALIGN_CENTER);
      
          ObjectCreate(0,"MetaBinaryOptions-simulator-exp-label-min",OBJ_LABEL,0,0,0);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-label-min",OBJPROP_ZORDER,5);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-label-min",OBJPROP_ANCHOR,ANCHOR_CENTER);
       ObjectSetString(0,"MetaBinaryOptions-simulator-exp-label-min",OBJPROP_TEXT,"minutes");
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-label-min",OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-label-min",OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-label-min",OBJPROP_XDISTANCE,151);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-label-min",OBJPROP_YDISTANCE,59);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-label-min",OBJPROP_COLOR,Gray);
       ObjectSetString(0,"MetaBinaryOptions-simulator-exp-label-min",OBJPROP_FONT,"Arial");
      
          ObjectCreate(0,"MetaBinaryOptions-simulator-exp-sec",OBJ_EDIT,0,0,0);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-sec",OBJPROP_ZORDER,5);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-sec",OBJPROP_ANCHOR,ANCHOR_CENTER);
       ObjectSetString(0,"MetaBinaryOptions-simulator-exp-sec",OBJPROP_TEXT,"0");
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-sec",OBJPROP_COLOR,Gray);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-sec",OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-sec",OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-sec",OBJPROP_XDISTANCE,123);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-sec",OBJPROP_YDISTANCE,50);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-sec",OBJPROP_XSIZE,40);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-sec",OBJPROP_YSIZE,20);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-sec",OBJPROP_BGCOLOR,White);
       ObjectSetString(0,"MetaBinaryOptions-simulator-exp-sec",OBJPROP_FONT,"Arial");
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-sec",OBJPROP_BORDER_COLOR,Gray);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-sec",OBJPROP_ALIGN,ALIGN_CENTER);
      
          ObjectCreate(0,"MetaBinaryOptions-simulator-exp-label-sec",OBJ_LABEL,0,0,0);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-label-sec",OBJPROP_ZORDER,5);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-label-sec",OBJPROP_ANCHOR,ANCHOR_CENTER);
       ObjectSetString(0,"MetaBinaryOptions-simulator-exp-label-sec",OBJPROP_TEXT,"seconds");
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-label-sec",OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-label-sec",OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-label-sec",OBJPROP_XDISTANCE,53);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-label-sec",OBJPROP_YDISTANCE,59);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-exp-label-sec",OBJPROP_COLOR,Gray);
       ObjectSetString(0,"MetaBinaryOptions-simulator-exp-label-sec",OBJPROP_FONT,"Arial");
       
          ObjectCreate(0,"MetaBinaryOptions-simulator-price-bg",OBJ_RECTANGLE_LABEL,0,0,0);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-price-bg",OBJPROP_ZORDER,4);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-price-bg",OBJPROP_XDISTANCE,280);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-price-bg",OBJPROP_YDISTANCE,90);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-price-bg",OBJPROP_XSIZE,260);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-price-bg",OBJPROP_YSIZE,20);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-price-bg",OBJPROP_BGCOLOR,C'243,243,243');
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-price-bg",OBJPROP_BORDER_TYPE,BORDER_SUNKEN);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-price-bg",OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-price-bg",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-price-bg",OBJPROP_WIDTH,0);
      
          ObjectCreate(0,"MetaBinaryOptions-simulator-price-label",OBJ_LABEL,0,0,0);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-price-label",OBJPROP_ZORDER,5);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-price-label",OBJPROP_ANCHOR,ANCHOR_CENTER);
       ObjectSetString(0,"MetaBinaryOptions-simulator-price-label",OBJPROP_TEXT,"0.00000");
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-price-label",OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-price-label",OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-price-label",OBJPROP_XDISTANCE,150);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-price-label",OBJPROP_YDISTANCE,100);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-price-label",OBJPROP_COLOR,White);
       ObjectSetString(0,"MetaBinaryOptions-simulator-price-label",OBJPROP_FONT,"Arial");
      
          ObjectCreate(0,"MetaBinaryOptions-simulator-amount-label",OBJ_LABEL,0,0,0);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-amount-label",OBJPROP_ZORDER,5);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-amount-label",OBJPROP_ANCHOR,ANCHOR_CENTER);
       ObjectSetString(0,"MetaBinaryOptions-simulator-amount-label",OBJPROP_TEXT,"Invest:");
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-amount-label",OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-amount-label",OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-amount-label",OBJPROP_XDISTANCE,150);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-amount-label",OBJPROP_YDISTANCE,130);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-amount-label",OBJPROP_COLOR,Gray);
       ObjectSetString(0,"MetaBinaryOptions-simulator-amount-label",OBJPROP_FONT,"Arial");
       
          ObjectCreate(0,"MetaBinaryOptions-simulator-amount",OBJ_EDIT,0,0,0);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-amount",OBJPROP_ZORDER,5);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-amount",OBJPROP_ANCHOR,ANCHOR_CENTER);
       ObjectSetString(0,"MetaBinaryOptions-simulator-amount",OBJPROP_TEXT,"25");
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-amount",OBJPROP_COLOR,Gray);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-amount",OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-amount",OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-amount",OBJPROP_XDISTANCE,185);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-amount",OBJPROP_YDISTANCE,140);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-amount",OBJPROP_XSIZE,70);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-amount",OBJPROP_YSIZE,20);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-amount",OBJPROP_BGCOLOR,White);
       ObjectSetString(0,"MetaBinaryOptions-simulator-amount",OBJPROP_FONT,"Arial");
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-amount",OBJPROP_BORDER_COLOR,Gray);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-amount",OBJPROP_ALIGN,ALIGN_CENTER);
       
          ObjectCreate(0,"MetaBinaryOptions-simulator-call",OBJ_BUTTON,0,0,0);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-call",OBJPROP_ZORDER,5);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-call",OBJPROP_ANCHOR,ANCHOR_CENTER);
       ObjectSetString(0,"MetaBinaryOptions-simulator-call",OBJPROP_TEXT,"UP");
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-call",OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-call",OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-call",OBJPROP_XDISTANCE,100);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-call",OBJPROP_YDISTANCE,90);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-call",OBJPROP_XSIZE,80);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-call",OBJPROP_YSIZE,80);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-call",OBJPROP_BGCOLOR,C'0,174,232');
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-call",OBJPROP_COLOR,White);
       ObjectSetString(0,"MetaBinaryOptions-simulator-call",OBJPROP_FONT,"Arial");
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-call",OBJPROP_BORDER_COLOR,White);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-call",OBJPROP_STATE,false);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-call",OBJPROP_SELECTABLE,false);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-call",OBJPROP_SELECTED,false);
      
          ObjectCreate(0,"MetaBinaryOptions-simulator-put",OBJ_BUTTON,0,0,0);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-put",OBJPROP_ZORDER,5);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-put",OBJPROP_ANCHOR,ANCHOR_CENTER);
       ObjectSetString(0,"MetaBinaryOptions-simulator-put",OBJPROP_TEXT,"DOWN");
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-put",OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-put",OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-put",OBJPROP_XDISTANCE,280);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-put",OBJPROP_YDISTANCE,90);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-put",OBJPROP_XSIZE,80);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-put",OBJPROP_YSIZE,80);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-put",OBJPROP_BGCOLOR,C'173,173,173');
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-put",OBJPROP_COLOR,White);
       ObjectSetString(0,"MetaBinaryOptions-simulator-put",OBJPROP_FONT,"Arial");
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-put",OBJPROP_BORDER_COLOR,White);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-put",OBJPROP_STATE,false);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-put",OBJPROP_SELECTABLE,false);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-put",OBJPROP_SELECTED,false);
      
          ObjectCreate(0,"MetaBinaryOptions-simulator-balance-bg",OBJ_RECTANGLE_LABEL,0,0,0);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-balance-bg",OBJPROP_ZORDER,4);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-balance-bg",OBJPROP_XDISTANCE,300);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-balance-bg",OBJPROP_YDISTANCE,180);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-balance-bg",OBJPROP_XSIZE,320);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-balance-bg",OBJPROP_YSIZE,50);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-balance-bg",OBJPROP_BGCOLOR,C'243,243,243');
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-balance-bg",OBJPROP_BORDER_TYPE,BORDER_SUNKEN);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-balance-bg",OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-balance-bg",OBJPROP_COLOR,Orange);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-balance-bg",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-balance-bg",OBJPROP_WIDTH,0);
      
          ObjectCreate(0,"MetaBinaryOptions-simulator-balance-label",OBJ_LABEL,0,0,0);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-balance-label",OBJPROP_ZORDER,5);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-balance-label",OBJPROP_ANCHOR,ANCHOR_CENTER);
       ObjectSetString(0,"MetaBinaryOptions-simulator-balance-label",OBJPROP_TEXT,"Balance : $"+DoubleToStr(balance,2));
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-balance-label",OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-balance-label",OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-balance-label",OBJPROP_XDISTANCE,150);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-balance-label",OBJPROP_YDISTANCE,195);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-balance-label",OBJPROP_COLOR,Gray);
       ObjectSetString(0,"MetaBinaryOptions-simulator-balance-label",OBJPROP_FONT,"Arial");
       
          ObjectCreate(0,"MetaBinaryOptions-simulator-winloss-label",OBJ_LABEL,0,0,0);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-winloss-label",OBJPROP_ZORDER,5);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-winloss-label",OBJPROP_ANCHOR,ANCHOR_CENTER);
       ObjectSetString(0,"MetaBinaryOptions-simulator-winloss-label",OBJPROP_TEXT,"0 Wins - 0 Losses - 0 Ties - 0.0%");
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-winloss-label",OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-winloss-label",OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-winloss-label",OBJPROP_XDISTANCE,150);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-winloss-label",OBJPROP_YDISTANCE,215);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-winloss-label",OBJPROP_COLOR,Gray);
       ObjectSetString(0,"MetaBinaryOptions-simulator-winloss-label",OBJPROP_FONT,"Arial");
   
      string fileName="!MBO_Simulator_Results_"+IntegerToString((int)TimeCurrent())+".csv";
      //if(IsTesting()) fileName="../../MQL4/Files/TESTER"+fileName;
      
      file_handle=FileOpen(fileName,FILE_WRITE|FILE_CSV);
      
      if(file_handle!=INVALID_HANDLE){
         Print("Simulator results in : "+TerminalInfoString(TERMINAL_DATA_PATH)+"\\Files\\"+fileName); 
         FileWrite(file_handle,"Open Time","Open Price","Direction","Expiry","Investment","Close Time","Close Price","Result","Payout","Balance");
      }
      else PrintFormat("Simulator results failed : ERROR N"+IntegerToString(GetLastError()));
      
      EventSetTimer(1);
  //}
   return(INIT_SUCCEEDED);
}

int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   //if(TimeCurrent()>0) {
      //double close[1]; CopyClose(NULL,0,0,1,close);
      if(Close[0]>price) ObjectSetInteger(0,"MetaBinaryOptions-simulator-price-bg",OBJPROP_BGCOLOR,C'0,174,232');
      else if(Close[0]<price) ObjectSetInteger(0,"MetaBinaryOptions-simulator-price-bg",OBJPROP_BGCOLOR,C'173,173,173');
      price=Close[0];
      ObjectSetString(0,"MetaBinaryOptions-simulator-price-label",OBJPROP_TEXT,DoubleToStr(price,5));
      
      updateBinary();
   //}
   return(rates_total);
  }
//+------------------------------------------------------------------+

void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
   if(id==CHARTEVENT_OBJECT_CLICK) {
      if(sparam=="MetaBinaryOptions-simulator-put") {
	     double expirySec = StringToDouble(ObjectGetString(0, "MetaBinaryOptions-simulator-exp-min", OBJPROP_TEXT))*60.0+StringToDouble(ObjectGetString(0, "MetaBinaryOptions-simulator-exp-sec", OBJPROP_TEXT));
        double amount    = StringToDouble(ObjectGetString(0, "MetaBinaryOptions-simulator-amount", OBJPROP_TEXT));
        double direction = -1;
        //MqlRates rates[1]; int copied = CopyRates(NULL,0,0,1,rates);
   	  //openBinary(rates[0].time,rates[0].close,expirySec,direction,amount); 
   	  openBinary((double)TimeCurrent(),Close[0],expirySec,direction,amount);
   	  ObjectSetInteger(0,"MetaBinaryOptions-simulator-put",OBJPROP_SELECTED,false);
   	  ObjectSetInteger(0,"MetaBinaryOptions-simulator-put",OBJPROP_STATE,false);
	   }
	   else if(sparam=="MetaBinaryOptions-simulator-call") {
	     double expirySec = StringToDouble(ObjectGetString(0, "MetaBinaryOptions-simulator-exp-min", OBJPROP_TEXT))*60.0+StringToDouble(ObjectGetString(0, "MetaBinaryOptions-simulator-exp-sec", OBJPROP_TEXT));
        double amount    = StringToDouble(ObjectGetString(0, "MetaBinaryOptions-simulator-amount", OBJPROP_TEXT));
        double direction = 1;
   	  //MqlRates rates[1]; int copied = CopyRates(NULL,0,0,1,rates);
   	  //openBinary(rates[0].time,rates[0].close,expirySec,direction,amount);  
   	  openBinary((double)TimeCurrent(),Close[0],expirySec,direction,amount);
   	  ObjectSetInteger(0,"MetaBinaryOptions-simulator-call",OBJPROP_SELECTED,false);
   	  ObjectSetInteger(0,"MetaBinaryOptions-simulator-call",OBJPROP_STATE,false);
	   }  
	  ChartRedraw();
   }            
}


int openBinary(double openTime, double openPrice, double expirySec, double direction, double amount){
   //Alert(TimeToStr(openTime,TIME_SECONDS)+" "+openPrice+" "+expirySec+" "+direction+" "+amount);
   orders=orders+1;
   ArrayResize(binary,orders,10000);
   binary[orders-1][0]=openTime;
   binary[orders-1][1]=openPrice;
   binary[orders-1][2]=expirySec;
   binary[orders-1][3]=direction;
   binary[orders-1][4]=amount;
   binary[orders-1][5]=0;
      
   if(direction==1){
          ObjectCreate(0,"MetaBinaryOptions-simulator-open-"+IntegerToString(orders),OBJ_ARROW,0,(datetime)openTime,openPrice);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-open-"+IntegerToString(orders),OBJPROP_ARROWCODE,233); //UP
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-open-"+IntegerToString(orders),OBJPROP_COLOR,C'90,90,90');
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-open-"+IntegerToString(orders),OBJPROP_ZORDER,6);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-open-"+IntegerToString(orders),OBJPROP_ANCHOR,ANCHOR_TOP);
   }
   else if(direction==-1){
          ObjectCreate(0,"MetaBinaryOptions-simulator-open-"+IntegerToString(orders),OBJ_ARROW,0,(datetime)openTime,openPrice);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-open-"+IntegerToString(orders),OBJPROP_ARROWCODE,234); //DN
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-open-"+IntegerToString(orders),OBJPROP_COLOR,C'90,90,90');
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-open-"+IntegerToString(orders),OBJPROP_ZORDER,6);
      ObjectSetInteger(0,"MetaBinaryOptions-simulator-open-"+IntegerToString(orders),OBJPROP_ANCHOR,ANCHOR_BOTTOM);
   }
   else Alert("ERROR: direction is invalid.");
   
       ObjectCreate(0,"MetaBinaryOptions-simulator-trend-"+IntegerToString(orders),OBJ_TREND,0,(datetime)openTime,openPrice,(datetime)openTime,openPrice);
   ObjectSetInteger(0,"MetaBinaryOptions-simulator-trend-"+IntegerToString(orders),OBJPROP_COLOR,C'90,90,90');
   ObjectSetInteger(0,"MetaBinaryOptions-simulator-trend-"+IntegerToString(orders),OBJPROP_RAY_LEFT,false);
   ObjectSetInteger(0,"MetaBinaryOptions-simulator-trend-"+IntegerToString(orders),OBJPROP_RAY_RIGHT,false);
   ObjectSetInteger(0,"MetaBinaryOptions-simulator-trend-"+IntegerToString(orders),OBJPROP_STYLE,STYLE_DOT);
   
   int pos=240;
   
       ObjectCreate(0,"MetaBinaryOptions-simulator-option-info-bg"+IntegerToString(orders),OBJ_RECTANGLE_LABEL,0,0,0);
   ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-info-bg"+IntegerToString(orders),OBJPROP_ZORDER,4);
   ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-info-bg"+IntegerToString(orders),OBJPROP_XDISTANCE,300);
   ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-info-bg"+IntegerToString(orders),OBJPROP_YDISTANCE,pos);
   ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-info-bg"+IntegerToString(orders),OBJPROP_XSIZE,320);
   ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-info-bg"+IntegerToString(orders),OBJPROP_YSIZE,40);
   ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-info-bg"+IntegerToString(orders),OBJPROP_BGCOLOR,C'173,173,173');
   ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-info-bg"+IntegerToString(orders),OBJPROP_BORDER_TYPE,BORDER_SUNKEN);
   ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-info-bg"+IntegerToString(orders),OBJPROP_CORNER,CORNER_RIGHT_UPPER);
   ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-info-bg"+IntegerToString(orders),OBJPROP_COLOR,Orange);
   ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-info-bg"+IntegerToString(orders),OBJPROP_STYLE,STYLE_SOLID);
   ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-info-bg"+IntegerToString(orders),OBJPROP_WIDTH,0);
   
   string directionString="ERROR"; if(direction==1) directionString="UP"; if(direction==-1) directionString="DOWN"; 
       ObjectCreate(0,"MetaBinaryOptions-simulator-option-info-label"+IntegerToString(orders),OBJ_LABEL,0,0,0);
   ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-info-label"+IntegerToString(orders),OBJPROP_ZORDER,5);
   ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-info-label"+IntegerToString(orders),OBJPROP_ANCHOR,ANCHOR_CENTER);
    ObjectSetString(0,"MetaBinaryOptions-simulator-option-info-label"+IntegerToString(orders),OBJPROP_TEXT,directionString+" "+Symbol()+" "+TimeToStr((datetime)openTime,TIME_SECONDS)+" "+DoubleToStr(openPrice,Digits)+" $"+DoubleToString(amount,2));
   ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-info-label"+IntegerToString(orders),OBJPROP_CORNER,CORNER_RIGHT_UPPER);
   ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-info-label"+IntegerToString(orders),OBJPROP_FONTSIZE,10);
   ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-info-label"+IntegerToString(orders),OBJPROP_XDISTANCE,150);
   ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-info-label"+IntegerToString(orders),OBJPROP_YDISTANCE,pos+10);
   ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-info-label"+IntegerToString(orders),OBJPROP_COLOR,White);
    ObjectSetString(0,"MetaBinaryOptions-simulator-option-info-label"+IntegerToString(orders),OBJPROP_FONT,"Arial");
    
       ObjectCreate(0,"MetaBinaryOptions-simulator-option-exp-label"+IntegerToString(orders),OBJ_LABEL,0,0,0);
   ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-exp-label"+IntegerToString(orders),OBJPROP_ZORDER,5);
   ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-exp-label"+IntegerToString(orders),OBJPROP_ANCHOR,ANCHOR_CENTER);
    ObjectSetString(0,"MetaBinaryOptions-simulator-option-exp-label"+IntegerToString(orders),OBJPROP_TEXT,expirySec<=60?DoubleToStr(expirySec,0)+"s":DoubleToStr(MathFloor(expirySec/60.0),0)+"m"+DoubleToStr(MathMod(expirySec,60),0)+"s");
   ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-exp-label"+IntegerToString(orders),OBJPROP_CORNER,CORNER_RIGHT_UPPER);
   ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-exp-label"+IntegerToString(orders),OBJPROP_FONTSIZE,10);
   ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-exp-label"+IntegerToString(orders),OBJPROP_XDISTANCE,150);
   ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-exp-label"+IntegerToString(orders),OBJPROP_YDISTANCE,pos+25);
   ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-exp-label"+IntegerToString(orders),OBJPROP_COLOR,White);
    ObjectSetString(0,"MetaBinaryOptions-simulator-option-exp-label"+IntegerToString(orders),OBJPROP_FONT,"Arial");
    
       ObjectCreate(0,"MetaBinaryOptions-simulator-option-exp-bar"+IntegerToString(orders),OBJ_RECTANGLE_LABEL,0,0,0);
   ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-exp-bar"+IntegerToString(orders),OBJPROP_ZORDER,4);
   ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-exp-bar"+IntegerToString(orders),OBJPROP_XDISTANCE,300);
   ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-exp-bar"+IntegerToString(orders),OBJPROP_YDISTANCE,pos+36);
   ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-exp-bar"+IntegerToString(orders),OBJPROP_XSIZE,320);
   ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-exp-bar"+IntegerToString(orders),OBJPROP_YSIZE,4);
   ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-exp-bar"+IntegerToString(orders),OBJPROP_BGCOLOR,C'0,174,232');
   ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-exp-bar"+IntegerToString(orders),OBJPROP_BORDER_TYPE,BORDER_SUNKEN);
   ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-exp-bar"+IntegerToString(orders),OBJPROP_CORNER,CORNER_RIGHT_UPPER);
   ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-exp-bar"+IntegerToString(orders),OBJPROP_STYLE,STYLE_SOLID);
   ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-exp-bar"+IntegerToString(orders),OBJPROP_WIDTH,0);
   
   return(true);
}

int updateBinary(){
   for(int i=0; i<ArrayRange(binary,0); i++){
      if(binary[i][5]==0){
         double closePrice = Close[0];
         if(ObjectFind(0,"MetaBinaryOptions-simulator-trend-"+IntegerToString(i+1))>=0) {
           //double close[1]; CopyClose(NULL,0,0,1,close);
           ObjectSetInteger(0,"MetaBinaryOptions-simulator-trend-"+IntegerToString(i+1),OBJPROP_TIME,1,(int)TimeCurrent());
            ObjectSetDouble(0,"MetaBinaryOptions-simulator-trend-"+IntegerToString(i+1),OBJPROP_PRICE,1,closePrice);
         }
         
         int remainingTime=(int)(binary[i][0]+binary[i][2]-TimeCurrent());
         if(remainingTime<0) remainingTime=0;
         string renTimeString;
         if(remainingTime<=60) renTimeString=DoubleToStr(remainingTime,0)+"s";
         else renTimeString=DoubleToStr(MathFloor(remainingTime/60.0),0)+"m"+DoubleToStr(MathMod(remainingTime,60),0)+"s";
         
          ObjectSetString(0,"MetaBinaryOptions-simulator-option-exp-label"+IntegerToString(i+1),OBJPROP_TEXT,DoubleToStr(closePrice,Digits)+" / "+renTimeString);
         ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-exp-bar"+IntegerToString(i+1),OBJPROP_XSIZE,(int)(remainingTime*320/binary[i][2]));
         
         if((binary[i][1]<closePrice && binary[i][3]==1) || (binary[i][1]>closePrice && binary[i][3]==-1))
            ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-info-bg"+IntegerToString(i+1),OBJPROP_BGCOLOR,C'85,198,136');
         else if((binary[i][1]<closePrice && binary[i][3]==-1) || (binary[i][1]>closePrice && binary[i][3]==1))
            ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-info-bg"+IntegerToString(i+1),OBJPROP_BGCOLOR,C'237,58,95');
         else
            ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-info-bg"+IntegerToString(i+1),OBJPROP_BGCOLOR,C'173,173,173');
         
         if(TimeCurrent()>=binary[i][0]+binary[i][2]){
            //double close[1]; CopyClose(NULL,0,0,1,close);
            
                ObjectCreate(0,"MetaBinaryOptions-simulator-close-"+IntegerToString(i+1),OBJ_ARROW,0,TimeCurrent(),closePrice);
            ObjectSetInteger(0,"MetaBinaryOptions-simulator-close-"+IntegerToString(i+1),OBJPROP_ARROWCODE,164);
            ObjectSetInteger(0,"MetaBinaryOptions-simulator-close-"+IntegerToString(i+1),OBJPROP_COLOR,C'90,90,90');
            ObjectSetInteger(0,"MetaBinaryOptions-simulator-close-"+IntegerToString(i+1),OBJPROP_ZORDER,7);
            ObjectSetInteger(0,"MetaBinaryOptions-simulator-close-"+IntegerToString(i+1),OBJPROP_ANCHOR,ANCHOR_CENTER);
            ObjectSetInteger(0,"MetaBinaryOptions-simulator-close-"+IntegerToString(i+1),OBJPROP_WIDTH,2);
         
            ObjectDelete(0,"MetaBinaryOptions-simulator-option-exp-bar"+IntegerToString(i+1));
            
            if(binary[i][3]==1){ //UP 
               if(binary[i][1]<closePrice){//WIN
                  binary[i][5]=1;
                  ObjectSetInteger(0,"MetaBinaryOptions-simulator-close-"+IntegerToString(i+1),OBJPROP_ARROWCODE,252);
                  nbwin++;
                  balance=balance+(payout/100)*binary[i][4];
                  ObjectSetString(0,"MetaBinaryOptions-simulator-option-exp-label"+IntegerToString(i+1),OBJPROP_TEXT,DoubleToStr(closePrice,Digits)+" / WON / +$"+DoubleToStr((1+payout/100)*binary[i][4],2));
                  ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-info-bg"+IntegerToString(i+1),OBJPROP_BGCOLOR,C'85,198,136');
                  ObjectSetInteger(0,"MetaBinaryOptions-simulator-open-"+IntegerToString(i+1),OBJPROP_COLOR,C'85,198,136');
                  ObjectSetInteger(0,"MetaBinaryOptions-simulator-trend-"+IntegerToString(i+1),OBJPROP_COLOR,C'85,198,136');
                  ObjectSetInteger(0,"MetaBinaryOptions-simulator-close-"+IntegerToString(i+1),OBJPROP_COLOR,C'85,198,136');
                  FileWrite(file_handle,TimeToStr((datetime)binary[i][0],TIME_DATE|TIME_SECONDS),DoubleToStr(binary[i][1],Digits),"UP",DoubleToStr(binary[i][2],0),DoubleToStr(binary[i][4],2),DoubleToStr(closePrice,Digits),TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS),"WIN",DoubleToStr((1+payout/100)*binary[i][4],2),DoubleToStr(balance,2));
               }
               else if(binary[i][1]>closePrice){//LOSS
                  binary[i][5]=-1;
                  ObjectSetInteger(0,"MetaBinaryOptions-simulator-close-"+IntegerToString(i+1),OBJPROP_ARROWCODE,251);
                  nbloss++;
                  balance=balance-binary[i][4];
                  ObjectSetString(0,"MetaBinaryOptions-simulator-option-exp-label"+IntegerToString(i+1),OBJPROP_TEXT,DoubleToStr(closePrice,Digits)+" / LOST / -$"+DoubleToStr(binary[i][4],2));
                  ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-info-bg"+IntegerToString(i+1),OBJPROP_BGCOLOR,C'237,58,95');
                  ObjectSetInteger(0,"MetaBinaryOptions-simulator-open-"+IntegerToString(i+1),OBJPROP_COLOR,C'237,58,95');
                  ObjectSetInteger(0,"MetaBinaryOptions-simulator-trend-"+IntegerToString(i+1),OBJPROP_COLOR,C'237,58,95');
                  ObjectSetInteger(0,"MetaBinaryOptions-simulator-close-"+IntegerToString(i+1),OBJPROP_COLOR,C'237,58,95');
                  FileWrite(file_handle,TimeToStr((datetime)binary[i][0],TIME_DATE|TIME_SECONDS),DoubleToStr(binary[i][1],Digits),"UP",DoubleToStr(binary[i][2],0),DoubleToStr(binary[i][4],2),DoubleToStr(closePrice,Digits),TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS),"LOSS",DoubleToStr(-binary[i][4],2),DoubleToStr(balance,2));
               }
               else{//EVEN
                  binary[i][5]=2;
                  nbeven++;
                  //balance=balance+binary[i][4];
                  ObjectSetString(0,"MetaBinaryOptions-simulator-option-exp-label"+IntegerToString(i+1),OBJPROP_TEXT,DoubleToStr(closePrice,Digits)+" / EVEN / $0");
                  ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-info-bg"+IntegerToString(i+1),OBJPROP_BGCOLOR,C'173,173,173');
                  ObjectSetInteger(0,"MetaBinaryOptions-simulator-open-"+IntegerToString(i+1),OBJPROP_COLOR,C'173,173,173');
                  ObjectSetInteger(0,"MetaBinaryOptions-simulator-trend-"+IntegerToString(i+1),OBJPROP_COLOR,C'173,173,173');
                  ObjectSetInteger(0,"MetaBinaryOptions-simulator-close-"+IntegerToString(i+1),OBJPROP_COLOR,C'173,173,173');
                  FileWrite(file_handle,TimeToStr((datetime)binary[i][0],TIME_DATE|TIME_SECONDS),DoubleToStr(binary[i][1],Digits),"UP",DoubleToStr(binary[i][2],0),DoubleToStr(binary[i][4],2),DoubleToStr(closePrice,Digits),TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS),"TIE","0",DoubleToStr(balance,2));
               }
            }
            else if(binary[i][3]==-1){ //DN
               if(binary[i][1]>closePrice){//WIN
                  binary[i][5]=1;
                  ObjectSetInteger(0,"MetaBinaryOptions-simulator-close-"+IntegerToString(i+1),OBJPROP_ARROWCODE,252);
                  nbwin++;
                  balance=balance+(payout/100)*binary[i][4];
                  ObjectSetString(0,"MetaBinaryOptions-simulator-option-exp-label"+IntegerToString(i+1),OBJPROP_TEXT,DoubleToStr(closePrice,Digits)+" / WON / +"+DoubleToStr((1+payout/100)*binary[i][4],2));
                  ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-info-bg"+IntegerToString(i+1),OBJPROP_BGCOLOR,C'85,198,136');
                  ObjectSetInteger(0,"MetaBinaryOptions-simulator-open-"+IntegerToString(i+1),OBJPROP_COLOR,C'85,198,136');
                  ObjectSetInteger(0,"MetaBinaryOptions-simulator-trend-"+IntegerToString(i+1),OBJPROP_COLOR,C'85,198,136');
                  ObjectSetInteger(0,"MetaBinaryOptions-simulator-close-"+IntegerToString(i+1),OBJPROP_COLOR,C'85,198,136');
                  FileWrite(file_handle,TimeToStr((datetime)binary[i][0],TIME_DATE|TIME_SECONDS),DoubleToStr(binary[i][1],Digits),"DOWN",DoubleToStr(binary[i][2],0),DoubleToStr(binary[i][4],2),DoubleToStr(closePrice,Digits),TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS),"WIN",DoubleToStr((1+payout/100)*binary[i][4],2),DoubleToStr(balance,2));
               }
               else if(binary[i][1]<closePrice){//LOSS
                  binary[i][5]=-1;
                  ObjectSetInteger(0,"MetaBinaryOptions-simulator-close-"+IntegerToString(i+1),OBJPROP_ARROWCODE,251);
                  nbloss++;
                  balance=balance-binary[i][4];
                  ObjectSetString(0,"MetaBinaryOptions-simulator-option-exp-label"+IntegerToString(i+1),OBJPROP_TEXT,DoubleToStr(closePrice,Digits)+" / LOST / -$"+DoubleToStr(binary[i][4],2));
                  ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-info-bg"+IntegerToString(i+1),OBJPROP_BGCOLOR,C'237,58,95');
                  ObjectSetInteger(0,"MetaBinaryOptions-simulator-open-"+IntegerToString(i+1),OBJPROP_COLOR,C'237,58,95');
                  ObjectSetInteger(0,"MetaBinaryOptions-simulator-trend-"+IntegerToString(i+1),OBJPROP_COLOR,C'237,58,95');
                  ObjectSetInteger(0,"MetaBinaryOptions-simulator-close-"+IntegerToString(i+1),OBJPROP_COLOR,C'237,58,95');
                  FileWrite(file_handle,TimeToStr((datetime)binary[i][0],TIME_DATE|TIME_SECONDS),DoubleToStr(binary[i][1],Digits),"DOWN",DoubleToStr(binary[i][2],0),DoubleToStr(binary[i][4],2),DoubleToStr(closePrice,Digits),TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS),"LOSS",DoubleToStr(-binary[i][4],2),DoubleToStr(balance,2));
               }
               else{//EVEN
                  binary[i][5]=2;
                  nbeven++;
                  //balance=balance+binary[i][4];
                  ObjectSetString(0,"MetaBinaryOptions-simulator-option-exp-label"+IntegerToString(i+1),OBJPROP_TEXT,DoubleToStr(closePrice,Digits)+" / EVEN / $0");
                  ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-info-bg"+IntegerToString(i+1),OBJPROP_BGCOLOR,C'173,173,173');
                  ObjectSetInteger(0,"MetaBinaryOptions-simulator-open-"+IntegerToString(i+1),OBJPROP_COLOR,C'173,173,173');
                  ObjectSetInteger(0,"MetaBinaryOptions-simulator-trend-"+IntegerToString(i+1),OBJPROP_COLOR,C'173,173,173');
                  ObjectSetInteger(0,"MetaBinaryOptions-simulator-close-"+IntegerToString(i+1),OBJPROP_COLOR,C'173,173,173');
                  FileWrite(file_handle,TimeToStr((datetime)binary[i][0],TIME_DATE|TIME_SECONDS),DoubleToStr(binary[i][1],Digits),"DOWN",DoubleToStr(binary[i][2],0),DoubleToStr(binary[i][4],2),DoubleToStr(closePrice,Digits),TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS),"TIE","0",DoubleToStr(balance,2));
               }
            }
            else {
               Alert("ERROR: Direction unknown.");
            } 
         }
      }
      else if((binary[i][5]==1 || binary[i][5]==-1 || binary[i][5]==2) && TimeCurrent()>=binary[i][0]+binary[i][2]+300) {
         ObjectDelete(0,"MetaBinaryOptions-simulator-option-info-bg"+IntegerToString(i+1));
         ObjectDelete(0,"MetaBinaryOptions-simulator-option-info-label"+IntegerToString(i+1));
         ObjectDelete(0,"MetaBinaryOptions-simulator-option-exp-label"+IntegerToString(i+1));
         ObjectDelete(0,"MetaBinaryOptions-simulator-option-exp-bar"+IntegerToString(i+1));
      }
   }
   
   organizePositions();
   
   double denom = nbwin+nbloss; if(denom==0.0) denom=1.0;
   winratio=100*nbwin/denom;
   
   ObjectSetString(0,"MetaBinaryOptions-simulator-balance-label",OBJPROP_TEXT,"Balance : $"+DoubleToStr(balance,2));
   ObjectSetString(0,"MetaBinaryOptions-simulator-winloss-label",OBJPROP_TEXT,IntegerToString(nbwin)+" Wins - "+IntegerToString(nbloss)+" Losses - "+IntegerToString(nbeven)+" Ties - "+DoubleToStr(winratio,1)+"%");
   
   return(true);
}

void organizePositions(){
   int pos=240;
   for(int i=0; i<ArrayRange(binary,0); i++){
      if(ObjectFind(0,"MetaBinaryOptions-simulator-option-info-bg"+IntegerToString(i+1))>=0){
         ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-info-bg"+IntegerToString(i+1),OBJPROP_YDISTANCE,0,pos);
         ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-info-label"+IntegerToString(i+1),OBJPROP_YDISTANCE,0,pos+10);
         ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-exp-label"+IntegerToString(i+1),OBJPROP_YDISTANCE,0,pos+25);
         ObjectSetInteger(0,"MetaBinaryOptions-simulator-option-exp-bar"+IntegerToString(i+1),OBJPROP_YDISTANCE,0,pos+36);
         pos=pos+50;
      }
   }
}

void OnTimer(){
   updateBinary();
}

void OnDeinit(const int reason){
   if(file_handle!=INVALID_HANDLE){
      FileClose(file_handle);
   }
   EventKillTimer();
}